local E, C, L, DB = unpack(select(2, ...)) -- Import Functions/Constants, Config, Locales

-- enable or disable an addon via command
SlashCmdList.DISABLE_ADDON = function(addon) local _, _, _, _, _, reason, _ = GetAddOnInfo(addon) if reason ~= "MISSING" then DisableAddOn(addon) ReloadUI() else print("|cffff0000Error, Addon '"..addon.."' not found.|r") end end
SLASH_DISABLE_ADDON1 = "/disable"
SlashCmdList.ENABLE_ADDON = function(addon) local _, _, _, _, _, reason, _ = GetAddOnInfo(addon) if reason ~= "MISSING" then EnableAddOn(addon) LoadAddOn(addon) ReloadUI() else print("|cffff0000Error, Addon '"..addon.."' not found.|r") end end
SLASH_ENABLE_ADDON1 = "/enable"
-- enable lua error by command
function SlashCmdList.LUAERROR(msg, editbox)
	if (msg == 'on') then
		SetCVar("scriptErrors", 1)
		-- because sometime we need to /rl to show error.
		ReloadUI()
	elseif (msg == 'off') then
		SetCVar("scriptErrors", 0)
	else
		print("/luaerror on - /luaerror off")
	end
end
SLASH_LUAERROR1 = '/luaerror'

local farm = false
local minisize = 250
local minisize2 = 250
function SlashCmdList.FARMMODE(msg, editbox)
	if farm == false then
		minisize = Minimap:GetWidth()
		if MinimapMover then
			minisize2 = MinimapMover:GetWidth()
			MinimapMover:SetSize(250, 250)
		end
		Minimap:SetSize(250, 250)
		farm = true
	else
		if MinimapMover then
			MinimapMover:SetSize(minisize2, minisize2)
		end	
		Minimap:SetSize(minisize, minisize)
		farm = false
	end

	LeftMiniPanel:SetWidth((Minimap:GetWidth() / 2) + 2)
	RightMiniPanel:SetWidth((Minimap:GetWidth() / 2) + 1)
	
	if E.Movers and not E.Movers["AurasMover"] or not E.Movers then
		AurasMover:ClearAllPoints()
		AurasMover:SetPoint("TOPRIGHT", Minimap, "TOPLEFT", E.Scale(-8), E.Scale(2))
	end	
end
SLASH_FARMMODE1 = '/farmmode'

SLASH_GM1 = "/gm"
SlashCmdList["GM"] = function() ToggleHelpFrame() end

SLASH_UIHELP1 = "/UIHelp"
SlashCmdList["UIHELP"] = E.UIHelp

SLASH_CONFIGURE1 = "/installui"
SlashCmdList.CONFIGURE = function() E.Install() end

SLASH_MOVEUI1 = '/moveui'
SlashCmdList.MOVEUI = function()		
	if InCombatLockdown() then return end
	
	E.ToggleMovers()
	
	if C["actionbar"].enable == true then
		E.ToggleABLock()
	end

	if ElvUF or oUF then
		E.MoveUF()
	end
end

SLASH_RESETMOVERS1 = '/resetui'
SlashCmdList.RESETMOVERS = function(arg) 
	if arg ~= "uf" then
		E.ResetMovers(arg) 
	end
	
	if oUF and arg == nil or arg == "" or arg == "uf" then 
		StaticPopup_Show("RESET_UF") 
	end 
end

--Command to fix the Combat Log if it breaks
local function CLFIX()
	CombatLogClearEntries()
end
SLASH_CLFIX1 = "/clfix"
SlashCmdList["CLFIX"] = CLFIX